datablock TSShapeConstructor(RCCarPlayerDts)
{
	baseShape  = "./RCCarPlayer.dts";
	sequence0  = "./RCCar_root.dsq root";

	sequence1  = "./RCCar_run.dsq run";
	sequence2  = "./RCCar_run.dsq walk";
	sequence3  = "./RCCar_run.dsq back";
	sequence4  = "./RCCar_run.dsq side";

	sequence5  = "./RCCar_root.dsq crouch";
	sequence6  = "./RCCar_run.dsq crouchRun";
	sequence7  = "./RCCar_run.dsq crouchBack";
	sequence8  = "./RCCar_run.dsq crouchSide";

	sequence9  = "./RCCar_root.dsq look";
	sequence10 = "./RCCar_root.dsq headside";
	sequence11 = "./RCCar_root.dsq headUp";

	sequence12 = "./RCCar_root.dsq jump";
	sequence13 = "./RCCar_root.dsq standjump";
	sequence14 = "./RCCar_root.dsq fall";
	sequence15 = "./RCCar_root.dsq land";

	sequence16 = "./RCCar_root.dsq armAttack";
	sequence17 = "./RCCar_root.dsq armReadyLeft";
	sequence18 = "./RCCar_root.dsq armReadyRight";
	sequence19 = "./RCCar_root.dsq armReadyBoth";
	sequence20 = "./RCCar_root.dsq spearready";  
	sequence21 = "./RCCar_root.dsq spearThrow";

	sequence22 = "./RCCar_root.dsq talk";  

	sequence23 = "./RCCar_root.dsq death1"; 
	
	sequence24 = "./RCCar_root.dsq shiftUp";
	sequence25 = "./RCCar_root.dsq shiftDown";
	sequence26 = "./RCCar_root.dsq shiftAway";
	sequence27 = "./RCCar_root.dsq shiftTo";
	sequence28 = "./RCCar_root.dsq shiftLeft";
	sequence29 = "./RCCar_root.dsq shiftRight";
	sequence30 = "./RCCar_root.dsq rotCW";
	sequence31 = "./RCCar_root.dsq rotCCW";

	sequence32 = "./RCCar_root.dsq undo";
	sequence33 = "./RCCar_root.dsq plant";

	sequence34 = "./RCCar_root.dsq sit";

	sequence35 = "./RCCar_root.dsq wrench";

   sequence36 = "./RCCar_root.dsq activate";
   sequence37 = "./RCCar_root.dsq activate2";

   sequence38 = "./RCCar_root.dsq leftrecoil";
};

datablock PlayerData(RCCarArmor : PlayerStandardArmor)
{
	shapefile = "./RCCarPlayer.dts";
	aircontrol=0;
	minlookangle=0;
	maxlookangle=0;
	renderFirstPerson=1;
	maxForwardSpeed=12;
	maxSideSpeed=0;
	maxBackwardSpeed=8;
	maxForwardCrouchSpeed=30;
	maxSideCrouchSpeed=0;
	maxBackwardCrouchSpeed=16;
	maxUnderWaterBackwardSpeed=3;
	maxUnderWaterForwardSpeed=5;
	maxUnderWaterSideSpeed=0;
	maxJumpSpeed=35;
	jetGroundEmitter="";
	JetGroundDistance=0;
	cameraVerticalOffset="0.25";
	cameraTilt="0.45";
	cameraMaxDist=5;
	cameraMinDist=0;
	boundingBox="4.5 4.5 2.5";
	crouchBoundingBox="4.5 4.5 2.5";
	canJet=0;
	JetEnergyDrain=5;
	maxEnergy=100;
	rechargeRate=1;
	pickupRadius=0;
	runForce=6000;
	jumpForce=700;
	ridable=0;
	canRide=0;
	uiname="";
};
datablock AudioProfile(rcbotDeploySound)
{
   filename    = "./explosion.wav";
   description = AudioClosest3d;
   preload = true;
};
function RCCar_Spawn(%p,%c,%a)
{
   %b=new AIPlayer()
   {
      datablock=RCCarArmor;
      position=%p;
      isRCBot=1;
      scale="1 1 1";
   };
   lolApp(%b,%c);
   MissionCleanup.add(%b);
   if(!isObject(RCBotGroup))
      new SimGroup(RCBotGroup){};
   RCBotGroup.add(%b);
   return %b;
}
function lolApp(%b,%c)
{
   %b.setNodeColor("Body",%c);
}
function AIPlayer::doOwnerCheck(%this)
{
   cancel(%this.ownerCheck);
   %o=%this.owner;
   if(!isObject(%o) || %o.getDamagePercent() == 1)
   {
      %this.handleDeath();
      %this.delete();
      return;
   }
   if(%this.getDamagePercent() == 1)
   {
      %this.handleDeath();
      %this.delete();
      return;
   }
   if(%this.owner.Client.getControlObject() != %this && %this.owner.Client.getControlObject() != %this.owner.Client.camera && %this.getDamagePercent() != 1)
      %this.owner.Client.setControlObject(%this);
   %this.ownerCheck=%this.schedule(100,doOwnerCheck);
}
function servercmdclearRCbots(%c)
{
   if(!%c.isAdmin)
      return;
   if(!isObject(RCBotGroup))
      return;
   if(RCBotGroup.getCount() == 0)
      return;
   messageAll('MsgClearBricks','\c3%1\c0 cleared RC bots (%2)',%c.name,RCBotGroup.getCount());
   RCCar_Cleanup();
}
function RCCar_Cleanup(%i)
{
   if(!isObject(RCBotGroup))
      return;
   if(RCBotGroup.getCount() > 0)
   {
      RCBotGroup.getObject(0).kill();
      RCBotGroup.remove(RCBotGroup.getObject(0));
   }
   else
      return;
   if(%i>=24)
      return schedule(16,0,RCCar_Cleanup);
	return RCCar_Cleanup(%i++);
}
datablock ProjectileData(rcBotProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Default;
   radiusDamageType    = $DamageType::Default;
   uiName = "";
};
datablock ParticleData(rcBotParticle) {
   dragCoefficient = "10";
   windCoefficient = "0";
   gravityCoefficient = "0";
   inheritedVelFactor = "1";
   constantAcceleration = "2";
   lifetimeMS = "300";
   lifetimeVarianceMS = "100";
   spinSpeed = "0";
   spinRandomMin = "0";
   spinRandomMax = "0";
   useInvAlpha = "0";
   animateTexture = "0";
   framesPerSec = "1";
   textureName = "./bolt";
   animTexName[0] = "./bolt";
   colors[0] = "1.000000 1.000000 0.466667 1.000000";
   colors[1] = "1.000000 1.000000 0.000000 1.000000";
   colors[2] = "1.000000 0.000000 0.000000 0.000000";
   colors[3] = "1.000000 1.000000 1.000000 1.000000";
   sizes[0] = "0.497467";
   sizes[1] = "0.247207";
   sizes[2] = "0";
   sizes[3] = "1";
   times[0] = "0";
   times[1] = "0.498039";
   times[2] = "1";
   times[3] = "2";
};
datablock ParticleEmitterData(rcBotEmitter) {
   className = "ParticleEmitterData";
   ejectionPeriodMS = "1";
   periodVarianceMS = "0";
   ejectionVelocity = "12";
   velocityVariance = "0";
   ejectionOffset = "0";
   thetaMin = "0";
   thetaMax = "60";
   phiReferenceVel = "0";
   phiVariance = "360";
   overrideAdvance = "1";
   orientParticles = "1";
   orientOnVelocity = "1";
   particles = "rcBotParticle";
   lifetimeMS = "0";
   lifetimeVarianceMS = "0";
   useEmitterSizes = "0";
   useEmitterColors = "0";
   uiName = "";
   doFalloff = "1";
   doDetail = "1";
};
datablock itemData(RCBotItem : PrintGun)
{
   uiName = "Remote Control";
   image = RCBotImage;
   docolorshift=1;
   colorshiftColor="1 1 0 1";
};
datablock shapeBaseImageData(RCBotImage : PrintGunImage)
{
   rotation=eulerToMatrix("0 180 0");
   offset="0 0 0";
   docolorshift=1;
   showBricks=0;
   colorshiftColor="1 1 0 1";
   item = RCBotItem;
   projectile=rcBotProjectile;
   stateEmitter[2] = "rcBotEmitter";
   stateEmitterTime[2] = 0.5;
};
function RCBotImage::onFire(%this,%obj,%slot)
{
   parent::onFire(%this,%obj,%slot);
   if(!isObject(%c=%obj.client))
      return;
   if(isObject(%obj.rcBot))
   {
      %c.centerprint("\c5You already have a RC Car",3);
      return;
   }
   if(%c.getControlObject() != %obj)
   {
      %c.centerprint("\c5You need the right body to do this!",3);
      return;
   }
   %start = %obj.getPosition();
   %targets = ($TypeMasks::FxBrickObjectType | $TypeMasks::FxBrickAlwaysObjectType |$TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
   %vec   = %obj.getForwardVector();
   %end   = vectorAdd(%start,vectorScale(%vec,4));
   %ray = containerRaycast(%start,%end,%targets,%obj);
   %col = firstWord(%ray);
   if(isObject(%col))
   {
      %c.centerprint("\c5You can't spawn a bot there!",3);
      return;
   }
   %p=vectorAdd(vectorScale(%obj.getForwardVector(),2.5),%obj.getPosition());
   %obj.rcBot=RCCar_Spawn(%p,%c.chestColor,%obj);
   %b=%obj.rcBot;
   %b.setTransform(%b.getPosition() SPC getWords(%obj.getTransform(),3,6));
   %b.setVelocity(vectorAdd(vectorScale(%obj.getEyeVector(),10),%obj.getVelocity()));
   %b.ownerName=%c.name;
   %b.ownerBL_ID=%c.bl_id;
   %b.ownerClient=%c;
   %b.owner=%obj;
   serverplay3d(rcbotDeploySound,%b.getTransform());
   %b.SpawnExplosion("SpawnProjectile",%b.scale);
   %b.doOwnerCheck();
   %c.setControlObject(%b);
   %c.centerprint("\c5Use your \c2Light\c5 to leave this mode",5);
}
if(isPackage(rcBot))
   deactivatepackage(rcBot);
package rcBot
{
   function servercmdLight(%c)
   {
      if(!isObject(%p=%c.player))
      {
         Parent::ServercmdLight(%c);
         return;
      }
      if(!isObject(%b=%c.player.rcBot))
      {
         Parent::ServercmdLight(%c);
         return;
      }
      %c.setControlObject(%p);
      serverplay3d(rcbotDeploySound,%b.getTransform());
      %p.rcBot.SpawnExplosion("SpawnProjectile",%p.rcBot.scale);
      %p.rcBot.delete();
   }
   function Armor::onDisabled(%this,%obj,%state)
   {
      Parent::onDisabled(%this,%obj,%state);
   }
   function AIPlayer::kill(%this)
   {
      parent::kill(%this);
   }
   function AIPlayer::handleDeath(%this)
   {
      if(isObject(%this.owner)&&%this.owner.client.getControlObject()!=%this.owner)
      {
         %this.owner.client.setControlObject(%this.owner);
         serverplay3d(rcbotDeploySound,%this.getTransform());
         %this.SpawnExplosion("SpawnProjectile",%this.scale);
      }
   }
   function Player::ActivateStuff(%this)
   {
      Parent::ActivateStuff(%this);
   }
   function Armor::onTrigger(%data,%player,%slot,%io)
	{
		Parent::onTrigger(%data,%player,%slot,%io);
	}
   function servercmdUseSprayCan(%c,%i)
   {
      parent::servercmdUseSprayCan(%c,%i);
      if(!isObject(%c.player))
         return;
      if(!isObject(%b=%c.player.rcBot))
         return;
      if(getSimTime() - %c.player.rcBot.lastRecolor < 50)
      {
         %c.centerprint("\c5Failure to change bot's color; Too Fast",3);
         return;
      }
      %c.player.rcBot.lastRecolor=getSimTime();
      lolApp(%b,getWords(getColorIDTable(%i),0,2)@" 1");
   }
};
activatepackage(rcBot);